<script setup lang="ts">
import { reactive, ref, onMounted, toRaw } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { message, Modal, Form, notification } from 'ant-design-vue/lib';
import { SizeType } from 'ant-design-vue/lib/config-provider';
import { MenuInfo } from 'ant-design-vue/lib/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/lib/table';
import UploadModal from '@/components/UploadModal/index.vue';
import TableColumnsDnd from '@/components/TableColumnsDnd/index.vue';
import {
  listAuth,
  getAuth,
  updateAuth,
  addAuth,
  delAuth,
  loadAuth,
  exportAuth,
  importAuthData,
  batchAuth,
  batchDelAuth,
} from '@/api/neUser/auth';
import useNeInfoStore from '@/store/modules/neinfo';
import useI18n from '@/hooks/useI18n';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import { saveAs } from 'file-saver';
const { t } = useI18n();

/**网元参数 */
let neOtions = ref<Record<string, any>[]>([]);

/**查询参数 */
let queryParams = reactive({
  /**网元ID */
  neId: undefined,
  /**移动编号 */
  imsi: '',
  /**排序字段 */
  sortField: 'imsi',
  /**排序方式 */
  sortOrder: 'asc',
  /**当前页数 */
  pageNum: 1,
  /**每页条数 */
  pageSize: 20,
});

/**查询参数重置 */
function fnQueryReset() {
  queryParams = Object.assign(queryParams, {
    imsi: '',
    sortField: 'imsi',
    sortOrder: 'asc',
    pageNum: 1,
    pageSize: 20,
  });
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**斑马纹 */
  striped: boolean;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
  /**勾选记录 */
  selectedRowKeys: (string | number)[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'small',
  striped: false,
  seached: true,
  data: [],
  selectedRowKeys: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: 'IMSI',
    dataIndex: 'imsi',
    align: 'center',
    sorter: true,
    width: 150,
  },
  {
    title: 'AMF',
    dataIndex: 'amf',
    align: 'center',
    width: 80,
  },
  {
    title: 'Status',
    dataIndex: 'status',
    align: 'center',
    width: 80,
  },
  // {
  //   title: 'KI',
  //   dataIndex: 'ki',
  //   align: 'center',
  //   width: 10,
  // },
  // {
  //   title: 'OPC',
  //   dataIndex: 'opc',
  //   align: 'center',
  //   width: 10,
  // },
  {
    title: 'Algo Index',
    dataIndex: 'algoIndex',
    align: 'center',
    width: 100,
  },
  {
    title: t('common.operate'),
    key: 'imsi',
    align: 'left',
  },
];

/**表格字段列排序 */
let tableColumnsDnd = ref<ColumnsType>([]);

/**表格分页器参数 */
let tablePagination = reactive({
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: false,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
    queryParams.pageNum = page;
    queryParams.pageSize = pageSize;
    fnGetList();
  },
});

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**表格斑马纹 */
function fnTableStriped(_record: unknown, index: number): any {
  return tableState.striped && index % 2 === 1 ? 'table-striped' : undefined;
}

/**表格分页、排序、筛选变化时触发操作, 排序方式，取值为 ascend descend */
function fnTableChange(pagination: any, filters: any, sorter: any, extra: any) {
  const { field, order } = sorter;
  if (order) {
    queryParams.sortField = field;
    queryParams.sortOrder = order.replace('end', '');
  } else {
    queryParams.sortOrder = 'asc';
  }
  fnGetList(1);
}

/**表格多选 */
function fnTableSelectedRowKeys(keys: (string | number)[]) {
  tableState.selectedRowKeys = keys;
}

/**对话框对象信息状态类型 */
type ModalStateType = {
  /**新增框或修改框是否显示 */
  visibleByEdit: boolean;
  /**批量新增新增框是否显示 */
  visibleByBatch: boolean;
  /**批量新增删除框是否显示 */
  visibleByBatchDel: boolean;
  /**标题 */
  title: string;
  /**表单数据 */
  from: Record<string, any>;
  /**表单数据 */
  BatchForm: Record<string, any>;
  /**表单数据 */
  BatchDelForm: Record<string, any>;
  /**确定按钮 loading */
  confirmLoading: boolean;
  /**更新加载数据按钮 loading */
  loadDataLoading: boolean;
};

/**对话框对象信息状态 */
let modalState: ModalStateType = reactive({
  visibleByEdit: false,
  visibleByBatch: false,
  visibleByBatchDel: false,
  title: 'UDM鉴权用户',
  from: {
    id: '',
    imsi: '',
    amf: '8000',
    ki: '',
    algoIndex: 0,
    opc: '',
  },
  BatchForm: {
    num: 1,
    imsi: '',
    amf: '8000',
    ki: '',
    algoIndex: 0,
    opc: '',
  },
  BatchDelForm: {
    num: 1,
    imsi: '',
  },
  confirmLoading: false,
  loadDataLoading: false,
});

/**对话框内表单属性和校验规则 */
const modalStateFrom = Form.useForm(
  modalState.from,
  reactive({
    imsi: [{ required: true, message: 'IMSI' + t('common.unableNull') }],
    amf: [{ required: true, message: 'AMF' + t('common.unableNull') }],
    ki: [{ required: true, message: 'KI' + t('common.unableNull') }],
    algoIndex: [
      { required: true, message: 'algoIndex' + t('common.unableNull') },
    ],
  })
);

/**对话框内批量添加表单属性和校验规则 */
const modalStateBatchFrom = Form.useForm(
  modalState.BatchForm,
  reactive({
    num: [
      {
        required: true,
        message: t('views.neUser.auth.numAdd') + t('common.unableNull'),
      },
    ],
    imsi: [{ required: true, message: 'IMSI' + t('common.unableNull') }],
    amf: [{ required: true, message: 'AMF' + t('common.unableNull') }],
    ki: [{ required: true, message: 'KI' + t('common.unableNull') }],
    algoIndex: [
      { required: true, message: 'algoIndex' + t('common.unableNull') },
    ],
  })
);

/**对话框内批量删除表单属性和校验规则 */
const modalStateBatchDelFrom = Form.useForm(
  modalState.BatchDelForm,
  reactive({
    num: [
      {
        required: true,
        message: t('views.neUser.auth.numDel') + t('common.unableNull'),
      },
    ],
    imsi: [{ required: true, message: 'IMSI' + t('common.unableNull') }],
  })
);

/**
 * 对话框弹出显示为 新增或者修改
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByEdit(row?: Record<string, any>) {
  if (!row) {
    modalStateFrom.resetFields(); //重置表单
    modalState.title = t('common.addText') + t('views.neUser.auth.authInfo');
    modalState.visibleByEdit = true;
  } else {
    if (modalState.confirmLoading) return;
    const hide = message.loading(t('common.loading'), 0);
    modalState.confirmLoading = true;
    const neID = queryParams.neId || '-';
    getAuth(neID, row.imsi)
      .then(res => {
        if (res.code === RESULT_CODE_SUCCESS) {
          modalState.from = Object.assign(modalState.from, res.data);
          modalState.title =
            t('common.editText') + t('views.neUser.auth.authInfo');
          modalState.visibleByEdit = true;
        } else {
          message.error(t('common.getInfoFail'), 2);
        }
      })
      .finally(() => {
        hide();
        modalState.confirmLoading = false;
      });
  }
}

/**
 * 对话框弹出显示为 批量新增,批量删除
 * @param noticeId 网元id, 不传为新增
 */
function fnModalVisibleByBatch(batchFlag?: number) {
  if (batchFlag) {
    modalStateBatchFrom.resetFields(); //重置表单
    modalState.title =
      t('views.neUser.auth.batchAddText') + t('views.neUser.auth.authInfo');
    modalState.visibleByBatch = true;
  } else {
    modalStateBatchFrom.resetFields(); //重置表单
    modalState.title =
      t('views.neUser.auth.batchDelText') + t('views.neUser.auth.authInfo');
    modalState.visibleByBatchDel = true;
  }
}

/**
 * 对话框弹出确认执行函数
 * 进行表达规则校验
 */
function fnModalOk() {
  modalStateFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.from);
      from.neId = queryParams.neId || '-';
      from.algoIndex = `${from.algoIndex}`;
      const result = from.id ? updateAuth(from) : addAuth(from);
      const hide = message.loading(t('common.loading'), 0);
      result
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByEdit = false;
            modalStateFrom.resetFields();
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出 批量新增操作确认执行函数
 * 进行表达规则校验
 */
function fnBatchModalOk() {
  modalStateBatchFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.BatchForm);
      from.neID = queryParams.neId || '-';
      from.algoIndex = `${from.algoIndex}`;
      const result = batchAuth(from);
      const hide = message.loading(t('common.loading'), 0);
      result
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByBatch = false;
            modalStateBatchFrom.resetFields();
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 对话框弹出 批量删除确认执行函数
 * 进行表达规则校验
 */
function fnBatchDelModalOk() {
  modalStateBatchDelFrom
    .validate()
    .then(e => {
      modalState.confirmLoading = true;
      const from = toRaw(modalState.BatchDelForm);

      const neID = queryParams.neId || '-';
      // const result = from.id ? updateAuth(from) : addAuth(neID, from);
      from.neID = neID;
      const result = batchDelAuth(from);
      const hide = message.loading(t('common.loading'), 0);
      result
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', { msg: modalState.title }),
              duration: 3,
            });
            modalState.visibleByBatchDel = false;
            modalStateBatchDelFrom.resetFields();
            fnGetList();
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          modalState.confirmLoading = false;
        });
    })
    .catch(e => {
      message.error(t('common.errorFields', { num: e.errorFields.length }), 3);
    });
}

/**
 * 批量添加对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnBatchModalCancel() {
  modalState.visibleByBatch = false;
  modalStateBatchFrom.resetFields();
}

/**
 * 批量删除对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnBatchDelModalCancel() {
  modalState.visibleByBatchDel = false;
  modalStateBatchDelFrom.resetFields();
}

/**
 * 对话框弹出关闭执行函数
 * 进行表达规则校验
 */
function fnModalCancel() {
  modalState.visibleByEdit = false;
  modalStateFrom.resetFields();
}

/**
 * UDM鉴权用户删除
 * @param imsi  编号imsi
 */
function fnRecordDelete(imsi: string) {
  const neID = queryParams.neId;
  if (!neID) return;
  let imsiMsg = imsi;
  if (imsi === '0') {
    imsiMsg = `${tableState.selectedRowKeys[0]}... ${t(
      'views.neUser.auth.numDel'
    )} ${tableState.selectedRowKeys.length}`;
    imsi = tableState.selectedRowKeys.join(',');
  }

  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.neUser.auth.delSure', { imsi: imsiMsg }),
    onOk() {
      modalState.loadDataLoading = true;
      const hide = message.loading(t('common.loading'), 0);
      delAuth(neID, imsi)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            const msgContent = t('common.msgSuccess', {
              msg: t('common.deleteText'),
            });
            message.success({
              content: `${msgContent} : ${imsiMsg}`,
              duration: 3,
            });
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          fnGetList();
          modalState.loadDataLoading = false;
        });
    },
  });
}

/**
 * UDM鉴权用户导出
 */
function fnRecordExport(type: string = 'txt') {
  const selectLen = tableState.selectedRowKeys.length;
  if (selectLen <= 0) return;
  const rows: Record<string, any>[] = tableState.data.filter(
    (row: Record<string, any>) =>
      tableState.selectedRowKeys.indexOf(row.imsi) >= 0
  );

  let content = '';
  if (type == 'txt') {
    for (const row of rows) {
      content += `${row.imsi},${row.ki},${row.algoIndex},${row.amf},${row.opc}\r\n`;
    }
  }
  if (type == 'csv') {
    content = `IMSI,ki,Algo Index,AMF,OPC\r\n`;
    for (const row of rows) {
      content += `${row.imsi},${row.ki},${row.algoIndex},${row.amf},${row.opc}\r\n`;
    }
  }

  const blob = new Blob([content], { type: 'text/plain;charset=utf-8' });
  saveAs(blob, `UDMAuth_${Date.now()}.${type}`);
}

/**列表导出 */
function fnExportList(type: string) {
  const neID = queryParams.neId;
  if (!neID) return;
  const key = 'exportAuth';
  message.loading({ content: t('common.loading'), key });
  exportAuth({
    neId: neID,
    type: type,
  }).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      message.success({
        content: t('common.msgSuccess', { msg: t('common.export') }),
        key,
        duration: 2,
      });
      saveAs(res.data, `UDMAuth_${Date.now()}.${type}`);
    } else {
      message.error({
        content: `${res.msg}`,
        key,
        duration: 2,
      });
    }
  });
}

/**重新加载数据 */
function fnLoadData() {
  const neID = queryParams.neId;
  if (tableState.loading || !neID) return;
  modalState.loadDataLoading = true;
  tablePagination.total = 0;
  tableState.data = [];
  tableState.loading = true; // 表格loading
  loadAuth(neID).then(res => {
    if (res.code === RESULT_CODE_SUCCESS) {
      const num = res.data;
      notification.success({
        message: t('views.neUser.auth.loadData'),
        description: t('views.neUser.auth.loadDataTip', { num }),
        duration: num < 10_0000 ? 10 : 30,
      });
      // 延迟10s后关闭loading刷新列表
      setTimeout(
        () => {
          modalState.loadDataLoading = false;
          tableState.loading = false; // 表格loading
          fnQueryReset();
        },
        num < 10_0000 ? 10_000 : 30_000
      );
    } else {
      message.error({
        content: t('common.getInfoFail'),
        duration: 3,
      });
    }
  });
}

/**查询列表, pageNum初始页数 */
function fnGetList(pageNum?: number) {
  if (tableState.loading) return;
  tableState.loading = true;
  if (pageNum) {
    queryParams.pageNum = pageNum;
    tablePagination.current = pageNum;
  }
  listAuth(toRaw(queryParams)).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      // 取消勾选
      if (tableState.selectedRowKeys.length > 0) {
        tableState.selectedRowKeys = [];
      }
      tablePagination.total = res.total;
      tableState.data = res.rows;
      if (tablePagination.total <=(queryParams.pageNum - 1) * tablePagination.pageSize &&queryParams.pageNum !== 1) {
        tableState.loading = false;
        fnGetList(queryParams.pageNum - 1);
      }
    }
    tableState.loading = false;
  });
}

/**对话框表格信息导入对象信息状态类型 */
type ModalUploadImportStateType = {
  /**是否显示 */
  visible: boolean;
  /**标题 */
  title: string;
  /**是否上传中 */
  loading: boolean;
  /**上传结果信息 */
  msg: string;
};

/**对话框表格信息导入对象信息状态 */
let uploadImportState: ModalUploadImportStateType = reactive({
  visible: false,
  title: t('components.UploadModal.uploadTitle'),
  loading: false,
  msg: '',
});

/**对话框表格信息导入弹出窗口 */
function fnModalUploadImportOpen() {
  uploadImportState.msg = '';
  uploadImportState.loading = false;
  uploadImportState.visible = true;
}

/**对话框表格信息导入关闭窗口 */
function fnModalUploadImportClose() {
  uploadImportState.visible = false;
  fnGetList();
}

/**对话框表格信息导入上传 */
function fnModalUploadImportUpload(file: File) {
  const neID = queryParams.neId;
  if (!neID) {
    return Promise.reject('Unknown network element');
  }
  let formData = new FormData();
  formData.append('file', file);
  formData.append('neId', neID);
  const hide = message.loading(t('common.loading'), 0);
  uploadImportState.loading = true;
  importAuthData(formData)
    .then(res => {
      uploadImportState.msg = res.msg;
    })
    .catch((err: { code: number; msg: string }) => {
      message.error(` ${err.msg}`);
    })
    .finally(() => {
      hide();
      uploadImportState.loading = false;
    });
}

onMounted(() => {
  // 获取网元网元列表
  useNeInfoStore()
    .fnNelist()
    .then(res => {
      if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.data)) {
        if (res.data.length > 0) {
          let arr: Record<string, any>[] = [];
          res.data.forEach(i => {
            if (i.neType === 'UDM') {
              arr.push({ value: i.neId, label: i.neName });
            }
          });
          neOtions.value = arr;
          if (arr.length > 0) {
            queryParams.neId = arr[0].value;
          }
        }
      } else {
        message.warning({
          content: t('common.noData'),
          duration: 2,
        });
      }
    })
    .finally(() => {
      // 获取列表数据
      fnGetList();
    });
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.neUser.auth.neType')" name="neId ">
              <a-select
                v-model:value="queryParams.neId"
                :options="neOtions"
                :placeholder="t('common.selectPlease')"
              />
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item label="IMSI" name="imsi">
              <a-input v-model:value="queryParams.imsi" allow-clear></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList(1)">
                  <template #icon>
                    <SearchOutlined />
                  </template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon>
                    <ClearOutlined />
                  </template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片左侧侧 -->
      <template #title>
        <div class="button-container">
          <a-button type="primary" @click.prevent="fnModalVisibleByEdit()">
            <template #icon>
              <PlusOutlined />
            </template>
            {{ t('common.addText') }}
          </a-button>

          <a-button type="primary" @click.prevent="fnModalVisibleByBatch(1)">
            <template #icon>
              <PlusOutlined />
            </template>
            {{ t('views.neUser.auth.batchAddText') }}
          </a-button>

          <a-button
            type="default"
            danger
            :disabled="tableState.selectedRowKeys.length <= 0"
            :loading="modalState.loadDataLoading"
            @click.prevent="fnRecordDelete('0')"
          >
            <template #icon><DeleteOutlined /></template>
            {{ t('views.neUser.auth.checkDel') }}
          </a-button>

          <a-button
            type="primary"
            danger
            ghost
            @click.prevent="fnModalVisibleByBatch(0)"
          >
            <template #icon>
              <DeleteOutlined />
            </template>
            {{ t('views.neUser.auth.batchDelText') }}
          </a-button>

          <a-popconfirm
            :title="t('views.neUser.auth.loadDataConfirm')"
            :ok-text="t('common.ok')"
            :cancel-text="t('common.cancel')"
            :disabled="modalState.loadDataLoading"
            @confirm="fnLoadData"
          >
            <a-button
              type="dashed"
              danger
              :disabled="modalState.loadDataLoading"
              :loading="modalState.loadDataLoading"
            >
              <template #icon><SyncOutlined /></template>
              {{ t('views.neUser.auth.loadData') }}
            </a-button>
          </a-popconfirm>

          <a-button type="dashed" @click.prevent="fnModalUploadImportOpen">
            <template #icon><ImportOutlined /></template>
            {{ t('views.neUser.auth.import') }}
          </a-button>

          <a-popconfirm
            :title="t('views.neUser.auth.exportConfirm')"
            placement="topRight"
            ok-text="TXT"
            ok-type="default"
            @confirm="fnExportList('txt')"
            :show-cancel="false"
            cancel-text="CSV"
            @cancel="fnExportList('csv')"
          >
            <a-button type="dashed">
              <template #icon><ExportOutlined /></template>
              {{ t('views.neUser.auth.export') }}
            </a-button>
          </a-popconfirm>

          <a-popconfirm
            :title="t('views.neUser.auth.checkExportConfirm')"
            placement="topRight"
            ok-text="TXT"
            ok-type="default"
            @confirm="fnRecordExport('txt')"
            :show-cancel="false"
            cancel-text="CSV"
            @cancel="fnRecordExport('csv')"
            :disabled="tableState.selectedRowKeys.length <= 0"
          >
            <a-button
              type="default"
              :disabled="tableState.selectedRowKeys.length <= 0"
            >
              <template #icon><ExportOutlined /></template>
              {{ t('views.neUser.auth.checkExport') }}
            </a-button>
          </a-popconfirm>
        </div>
      </template>

      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <div class="button-container">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.zebra') }}</template>
            <a-switch
              v-model:checked="tableState.striped"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <TableColumnsDnd
            :columns="tableColumns"
            v-model:columns-dnd="tableColumnsDnd"
          ></TableColumnsDnd>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </div>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="imsi"
        :columns="tableColumnsDnd"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :row-class-name="fnTableStriped"
        :pagination="tablePagination"
        :scroll="{ y: 'calc(100vh - 480px)' }"
        @change="fnTableChange"
        @resizeColumn="(w:number, col:any) => (col.width = w)"
        :row-selection="{
          type: 'checkbox',
          selectedRowKeys: tableState.selectedRowKeys,
          onChange: fnTableSelectedRowKeys,
        }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'imsi'">
            <a-space :size="8" align="center">
              <a-tooltip>
                <template #title>{{ t('common.editText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnModalVisibleByEdit(record)"
                >
                  <template #icon>
                    <FormOutlined />
                  </template>
                </a-button>
              </a-tooltip>
              <a-tooltip>
                <template #title>{{ t('common.deleteText') }}</template>
                <a-button
                  type="link"
                  @click.prevent="fnRecordDelete(record.imsi)"
                >
                  <template #icon>
                    <DeleteOutlined />
                  </template>
                </a-button>
              </a-tooltip>
            </a-space>
          </template>
        </template>
      </a-table>
    </a-card>

    <!-- 新增框或修改框 -->
    <DraggableModal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByEdit"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnModalOk"
      @cancel="fnModalCancel"
    >
      <a-form
        name="modalStateFrom"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :labelWrap="true"
      >
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="IMSI"
              name="imsi"
              v-bind="modalStateFrom.validateInfos.imsi"
            >
              <a-input v-model:value="modalState.from.imsi" allow-clear>
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.imsiTip') }}<br />
                      {{ t('views.neUser.auth.imsiTip1') }}<br />
                      {{ t('views.neUser.auth.imsiTip2') }}<br />
                      {{ t('views.neUser.auth.imsiTip3') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item label="Status" name="status">
              <a-select value="1">
                <a-select-option value="1">Active</a-select-option>
                <a-select-option value="0">Inactive</a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="AMF"
              name="amf"
              v-bind="modalStateFrom.validateInfos.amf"
            >
              <a-input
                v-model:value="modalState.from.amf"
                allow-clear
                :maxlength="4"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.amfTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Algo Index"
              name="algo"
              v-bind="modalStateFrom.validateInfos.algoIndex"
            >
              <a-input-number
                v-model:value="modalState.from.algoIndex"
                style="width: 100%"
                :min="0"
                :max="15"
                placeholder="0 ~ 15"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.algoIndexTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input-number>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="KI"
              name="ki"
              v-bind="modalStateFrom.validateInfos.ki"
            >
              <a-input
                v-model:value="modalState.from.ki"
                allow-clear
                :maxlength="32"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.kiTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="OPC"
              name="opc"
              v-bind="modalStateFrom.validateInfos.opc"
            >
              <a-input
                v-model:value="modalState.from.opc"
                allow-clear
                :maxlength="32"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.opcTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </DraggableModal>

    <!-- 批量新增框 -->
    <DraggableModal
      width="800px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByBatch"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnBatchModalOk"
      @cancel="fnBatchModalCancel"
    >
      <a-form
        name="modalStateBatchFrom"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :labelWrap="true"
      >
        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              :label="t('views.neUser.auth.numAdd')"
              name="num"
              v-bind="modalStateBatchFrom.validateInfos.num"
            >
              <a-input-number
                v-model:value="modalState.BatchForm.num"
                style="width: 100%"
                :min="1"
                :max="1000000"
                placeholder="<=1000000"
              ></a-input-number>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="IMSI"
              name="imsi"
              v-bind="modalStateBatchFrom.validateInfos.imsi"
            >
              <a-input v-model:value="modalState.BatchForm.imsi" allow-clear>
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.imsiTip') }}<br />
                      {{ t('views.neUser.auth.imsiTip1') }}<br />
                      {{ t('views.neUser.auth.imsiTip2') }}<br />
                      {{ t('views.neUser.auth.imsiTip3') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item label="Status" name="status">
              <a-select value="1">
                <a-select-option value="1">Active</a-select-option>
                <a-select-option value="0">Inactive</a-select-option>
              </a-select>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="AMF"
              name="amf"
              v-bind="modalStateBatchFrom.validateInfos.amf"
            >
              <a-input
                v-model:value="modalState.BatchForm.amf"
                allow-clear
                :maxlength="4"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.amfTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="Algo Index"
              name="algo"
              v-bind="modalStateBatchFrom.validateInfos.algoIndex"
            >
              <a-input-number
                v-model:value="modalState.BatchForm.algoIndex"
                style="width: 100%"
                :min="0"
                :max="15"
                placeholder="0 ~ 15"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.algoIndexTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input-number>
            </a-form-item>
          </a-col>
        </a-row>

        <a-row :gutter="16">
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="KI"
              name="ki"
              v-bind="modalStateBatchFrom.validateInfos.ki"
            >
              <a-input
                v-model:value="modalState.BatchForm.ki"
                allow-clear
                :maxlength="32"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.kiTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="12" :md="12" :xs="24">
            <a-form-item
              label="OPC"
              name="opc"
              v-bind="modalStateBatchFrom.validateInfos.opc"
            >
              <a-input
                v-model:value="modalState.BatchForm.opc"
                allow-clear
                :maxlength="32"
              >
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.opcTip') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </DraggableModal>

    <!-- 批量删除框 -->
    <DraggableModal
      width="500px"
      :keyboard="false"
      :mask-closable="false"
      :visible="modalState.visibleByBatchDel"
      :title="modalState.title"
      :confirm-loading="modalState.confirmLoading"
      @ok="fnBatchDelModalOk"
      @cancel="fnBatchDelModalCancel"
    >
      <a-form
        name="modalStateBatchDelFrom"
        layout="horizontal"
        :label-col="{ span: 6 }"
        :labelWrap="true"
      >
        <a-row :gutter="16">
          <a-col :lg="24" :md="24" :xs="24">
            <a-form-item
              :label="t('views.neUser.auth.startIMSI')"
              name="imsi"
              v-bind="modalStateBatchDelFrom.validateInfos.imsi"
            >
              <a-input v-model:value="modalState.BatchDelForm.imsi" allow-clear>
                <template #prefix>
                  <a-tooltip placement="topLeft">
                    <template #title>
                      {{ t('views.neUser.auth.imsiTip') }}<br />
                      {{ t('views.neUser.auth.imsiTip1') }}<br />
                      {{ t('views.neUser.auth.imsiTip2') }}<br />
                      {{ t('views.neUser.auth.imsiTip3') }}
                    </template>
                    <InfoCircleOutlined style="color: rgba(0, 0, 0, 0.45)" />
                  </a-tooltip>
                </template>
              </a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="24" :md="24" :xs="24">
            <a-form-item
              :label="t('views.neUser.auth.numDel')"
              name="num"
              v-bind="modalStateBatchDelFrom.validateInfos.num"
            >
              <a-input-number
                v-model:value="modalState.BatchDelForm.num"
                style="width: 100%"
                :min="1"
                :max="1000000"
                placeholder="<=1000000"
              ></a-input-number>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </DraggableModal>

    <!-- 上传导入表格数据文件框 -->
    <UploadModal
      :title="uploadImportState.title"
      :loading="uploadImportState.loading"
      @upload="fnModalUploadImportUpload"
      @close="fnModalUploadImportClose"
      v-model:visible="uploadImportState.visible"
      :ext="['.txt']"
    >
      <template #default>
        <a-textarea
          :disabled="true"
          :hidden="!uploadImportState.msg"
          :value="uploadImportState.msg"
          :auto-size="{ minRows: 2, maxRows: 8 }"
          style="background-color: transparent; color: rgba(0, 0, 0, 0.85)"
        />
      </template>
    </UploadModal>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}

.table :deep(.table-striped) td {
  background-color: #fafafa;
}

.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
